﻿--System Functions module

local width, height = 250, 18

function SN:SNCreateBG(frame)
	print(IsAddOnLoaded("ElvUI"))
	if(IsAddOnLoaded("ElvUI")) then
		local bg = CreateFrame("Frame")
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("LOW")
		bg:Show()
	end
end

function SN:CreateBar(group, cooldown, caster, guid, spell)
	
	--Start the CD Timer
	local bar = SN.timers:NewBar(group, width, height, SN.V.media.minTex)
		
	local class, classFileName = UnitClass(caster)
	local colortmp = RAID_CLASS_COLORS[classFileName]
	color = { colortmp.r, colortmp.g, colortmp.b }

	bar:SetIcon(select(3, GetSpellInfo(cooldown['spellID'])))
	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetColor(color)
	
	if group == SN.F.cooldowns then
		bar:SetDuration(cooldown['CD'])
	elseif group == SN.F.debuffs then
		bar:SetDuration(cooldown['dur'])
	end
	
	bar:SetLabelFont(SN.V.media.font, 14)
	bar:SetLabel(spell)
	SN:SNCreateBG(bar)
	bar.RegisterCallback(self, "FancyBar_BarStop", "CleanUpBars")
	bar:Start()
	
end

function SN:CleanUpBars(callback, bar)

end

function SN:StartCD(group, cooldown, guid, caster, spell, type)

	if(SN.profileDB.castannounce) then
		local name = select(1, GetSpellInfo(cooldown['spellID']))
		if group == SN.F.cooldowns then
			local cd = cooldown['CD'] / 60
		elseif group == SN.F.debuffs then
			local cd = cooldown['dur']
		end
		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(caster.." Casts "..name.." "..cd.."Min".." CD" ,"RAID")
		else
			SendChatMessage(caster.." Casts "..name.." "..cd.."Min".." CD" ,"PARTY")
		end
	end

	local bar = SN:CreateBar(group, cooldown, caster, guid, spell)
	
end

--function 